# keep around ready for later user
%global alphatag 1dc9
%global numcomm 11


%global gitver %{?numcomm:.%{numcomm}}%{?alphatag:-%{alphatag}}%{?dirty:-%{dirty}}
%global gittarver %{?numcomm:-%{numcomm}}%{?alphatag:-g%{alphatag}}%{?dirty:-%{dirty}}

%bcond_with html_man
%bcond_with glue
%bcond_without python3
%bcond_with run_build_tests

## User and group to use for nonprivileged services (should be in sync with pacemaker)
%global uname hacluster
%global gname haclient

# Defined on RHEL 8 and Fedora
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?__python3: %global __python3 /usr/bin/python3}

%if 0%{?with_python3}
%global __python_full_path %{__python3}
%else
%global __python_full_path %{__python2}
%endif

%if 0%{?suse_version}
%global booth_docdir %{_defaultdocdir}/%{name}
%else
# newer fedora distros have _pkgdocdir, rely on that when
# available
%{!?_pkgdocdir: %global _pkgdocdir %%{_docdir}/%{name}-%{version}}
# Directory where we install documentation
%global booth_docdir %{_pkgdocdir}
%endif

%global test_path   	%{_datadir}/booth/tests

%if 0%{?suse_version}
%define _libexecdir %{_libdir}
%define _fwdefdir %{_libexecdir}/firewalld/services
%endif
%define with_extra_warnings   	0
%define with_debugging  	0
%define without_fatal_warnings 	1
%if 0%{?fedora} || 0%{?centos} || 0%{?rhel}
%define pkg_group System Environment/Daemons
%else
%define pkg_group Productivity/Clustering/HA
%endif

%global release 1

Name:           booth
Url:            https://github.com/ClusterLabs/booth
Summary:        Ticket Manager for Multi-site Clusters
License:        GPL-2.0-or-later
Group:          %{pkg_group}
Version:        1.1
Release:        %{?numcomm:%{numcomm}.}%{release}%{?alphatag:.%{alphatag}}%{?dirty:.%{dirty}}%{?alphatag:.git}%{?dist}
Source:         https://github.com/ClusterLabs/booth/archive/v%{version}%{?gittarver}/%{name}-%{version}%{?gitver}.tar.gz
Source1:        %name-rpmlintrc
BuildRequires:  asciidoc
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  pkgconfig
%if 0%{?suse_version}
BuildRequires:  glib2-devel
# SuSEFirewall2 replaced by Firewalld (fate#323460)
BuildRequires:  firewall-macros
%else
BuildRequires:  pkgconfig(glib-2.0)
%endif
BuildRequires:  libgcrypt-devel
%if 0%{?fedora} || 0%{?centos} || 0%{?rhel}
BuildRequires:  pacemaker-libs-devel
%else
%if 0%{?suse_version} > 1500
BuildRequires:  libpacemaker3-devel
%else
BuildRequires:  libpacemaker-devel
%endif
%endif
%if 0%{?with_glue}
%if 0%{?fedora} || 0%{?centos} || 0%{?rhel}
BuildRequires:  cluster-glue-libs-devel
%else
BuildRequires:  libglue-devel
%endif
%else
# logging provider
BuildRequires:  pkgconfig(libqb)
# random2range provider
BuildRequires:  pkgconfig(glib-2.0)
# nametag provider
BuildRequires:  pkgconfig(libsystemd)
%endif
BuildRequires:  libxml2-devel
BuildRequires:  zlib-devel
%if 0%{?fedora} || 0%{?centos} || 0%{?rhel}
Requires:       pacemaker >= 1.1.8
%if 0%{?with_glue}
Requires:       cluster-glue-libs >= 1.0.6
%endif
%else
Requires:       pacemaker-ticket-support >= 2.0
%endif

# for check scriptlet
%if 0%{?with_python3}
BuildRequires:  python3-devel
%else
BuildRequires:  python
%endif

# For Fedora compatibility
Provides: booth-core
Provides: booth-site
Provides: booth-arbitrator

%description
Booth manages tickets which authorize cluster sites located in
geographically dispersed locations to run resources. It
facilitates support of geographically distributed clustering in
Pacemaker.

%prep
%setup -q -n %{name}-%{version}%{?gitver}

%build
./autogen.sh
%configure \
	--with-initddir=%{_initrddir} \
	--docdir=%{booth_docdir} \
	%{?with_html_man:--with-html_man} \
	%{!?with_glue:--without-glue} \
	PYTHON=%{__python_full_path}

make

%install
make DESTDIR=$RPM_BUILD_ROOT install docdir=%{booth_docdir}

mkdir -p %{buildroot}/%{_mandir}/man8/
gzip < docs/boothd.8 > %{buildroot}/%{_mandir}/man8/booth.8.gz
ln %{buildroot}/%{_mandir}/man8/booth.8.gz %{buildroot}/%{_mandir}/man8/boothd.8.gz

%if %{defined _unitdir}
# systemd
mkdir -p %{buildroot}/%{_unitdir}
cp -a conf/booth@.service %{buildroot}/%{_unitdir}/booth@.service
cp -a conf/booth-arbitrator.service %{buildroot}/%{_unitdir}/booth-arbitrator.service
ln -s /usr/sbin/service %{buildroot}%{_sbindir}/rcbooth-arbitrator
%else
# sysV init
ln -s ../../%{_initddir}/booth-arbitrator %{buildroot}%{_sbindir}/rcbooth-arbitrator
%endif

#install test-parts

mkdir -p %{buildroot}/%{test_path}/conf
cp -a test %{buildroot}/%{test_path}/
cp -a conf/booth.conf.example %{buildroot}/%{test_path}/conf/
chmod +x %{buildroot}/%{test_path}/test/booth_path
chmod +x %{buildroot}/%{test_path}/test/live_test.sh

mkdir -p %{buildroot}/%{test_path}/src/
ln -s %{_sbindir}/boothd %{buildroot}/%{test_path}/src/
rm -f %{buildroot}/%{test_path}/test/*.pyc

# Generate runtests.py and boothtestenv.py
sed -e 's#PYTHON_SHEBANG#%{__python_full_path} -Es#g' \
    -e 's#TEST_SRC_DIR#%{test_path}/test#g' \
    -e 's#TEST_BUILD_DIR#%{test_path}/test#g' \
    %{buildroot}/%{test_path}/test/runtests.py.in > %{buildroot}/%{test_path}/test/runtests.py

chmod +x %{buildroot}/%{test_path}/test/runtests.py

sed -e 's#PYTHON_SHEBANG#%{__python_full_path} -Es#g' \
    -e 's#TEST_SRC_DIR#%{test_path}/test#g' \
    -e 's#TEST_BUILD_DIR#%{test_path}/test#g' \
    %{buildroot}/%{test_path}/test/boothtestenv.py.in > %{buildroot}/%{test_path}/test/boothtestenv.py

%if 0%{?suse_version}
#Firewalld rule
mkdir -p $RPM_BUILD_ROOT/%{_fwdefdir}
install -m 644 contrib/geo-cluster.firewalld.xml $RPM_BUILD_ROOT/%{_fwdefdir}/booth.xml
#install -m 644 %{S:2} $RPM_BUILD_ROOT/%{_fwdefdir}/booth

%post
%firewalld_reload
%endif

%check
%if 0%{?with_run_build_tests}
echo "%%with_run_build_tests set to %with_run_build_tests; including tests"
make check
%else
echo "%%with_run_build_tests set to %with_run_build_tests; skipping tests"
%endif

%files
%{_sbindir}/booth
%{_sbindir}/boothd
%{_sbindir}/booth-keygen
%{_sbindir}/geostore
%{_mandir}/man8/booth.8.gz
%{_mandir}/man8/boothd.8.gz
%{_mandir}/man8/booth-keygen.8.gz
%{_mandir}/man8/geostore.8.gz
%dir /usr/lib/ocf
%dir /usr/lib/ocf/resource.d
%dir /usr/lib/ocf/resource.d/pacemaker
%dir /usr/lib/ocf/resource.d/booth
%dir /usr/lib/ocf/lib
%dir /usr/lib/ocf/lib/booth
%dir %{_sysconfdir}/booth
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/booth/
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/booth/cores
%{_sbindir}/rcbooth-arbitrator
/usr/lib/ocf/resource.d/pacemaker/booth-site
/usr/lib/ocf/lib/booth/geo_attr.sh
/usr/lib/ocf/resource.d/booth/geostore
%config %{_sysconfdir}/booth/booth.conf.example
%if 0%{?suse_version}
%dir %{_libexecdir}/firewalld
%dir %{_fwdefdir}
%{_fwdefdir}/booth.xml
%endif

%if %{defined _unitdir}
%{_unitdir}/booth@.service
%{_unitdir}/booth-arbitrator.service
%exclude %{_initddir}/booth-arbitrator
%else
%{_initddir}/booth-arbitrator
%endif

%dir %{_datadir}/booth
%{_datadir}/booth/service-runnable

%dir %{_datadir}/pkgconfig
%{_datadir}/pkgconfig/booth.pc

%doc AUTHORS README COPYING
%doc README.upgrade-from-v0.1

%if 0%{?with_html_man}
%{booth_docdir}/booth-keygen.8.html
%{booth_docdir}/boothd.8.html
%{booth_docdir}/geostore.8.html
%endif

%package test
Summary:        Test scripts for Booth
Group:          %{pkg_group}
Requires:       booth
Requires:       gdb
Requires:       %{__python_full_path}
%if 0%{?with_python3}
Requires:       python3-pexpect
%else
Requires:       python-pexpect
%endif

%description test
This package contains automated tests for Booth,
the Cluster Ticket Manager for Pacemaker.

%files test
%doc %{booth_docdir}/README-testing
%{test_path}
%dir /usr/lib/ocf
%dir /usr/lib/ocf/resource.d
%dir /usr/lib/ocf/resource.d/booth
/usr/lib/ocf/resource.d/booth/sharedrsc

%changelog
